#include "glib.h"

static GList *init_functions = NULL;
typedef gint (*GtkFunction)         (gpointer   data);
typedef struct _GtkInitFunction
{
  GtkFunction function;
  gpointer data;
} GtkInitFunction;
static GSList *main_loops = NULL;


gboolean
start_here()
{
  g_print("start_here...\n");
}

gboolean
loop()
{
  int i = 0;
  for (i=0;i<100;i++){
    g_print("%d ",i);
    g_usleep(1000000);
  }
  return TRUE;
}
    
void
end_here()
{
  g_print("this is the end!\n");
}

int
main ()
{
  GList *tmp_list;
  GList *functions;
  GList *quit_functions = NULL;
  GtkInitFunction *init;
  GMainLoop *loop;
  GtkFunction *func;
  
  init = g_new (GtkInitFunction, 1);
  init->function = (GSourceFunc*)start_here;
  init->data = NULL;
  
  init_functions = g_list_prepend (init_functions, init); 
  
  g_print("gtk_main\n");

  g_idle_add (loop, NULL);

  loop = g_main_new (TRUE);
  main_loops = g_slist_prepend (main_loops, loop);

  tmp_list = functions = init_functions;
  init_functions = NULL;
  
  while (tmp_list)
    {
      init = tmp_list->data;
      tmp_list = tmp_list->next;
      
      (* init->function) (init->data);
      g_free (init);
    }
  g_list_free (functions);

  g_print("checking if g_main_is_running\n");

  if (g_main_is_running (main_loops->data))
    {
      g_print("running g_main_run()\n");
      g_main_run (loop);
    }
  
  g_print("g_main_run has completed!\n");
        
  main_loops = g_slist_remove (main_loops, loop);
 
  g_main_destroy (loop);

}
